---
title: XRSession
slug: Web/API/XRSession
tags:
  - API
  - AR
  - Augmented Reality
  - Interface
  - Reference
  - VR
  - Virtual Reality
  - WebXR Device API
  - XRSession
---
<div>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}{{Draft}}</div>

<p>The WebXR Device API's <code><strong>XRSession</strong></code> interface represents an ongoing XR session, providing methods and properties used to interact with and control the session. To open a WebXR session, use the {{domxref("XRSystem")}} interface's {{domxref("XRSystem.requestSession", "requestSession()")}} method.</p>

<p>With <code>XRSession</code> methods, you can poll the viewer's position and orientation (the {{domxref("XRViewerPose")}}), gather information about the user's environment, and present imagery to the user. <code>XRSession</code> supports both inline and immersive virtual and augmented reality modes.</p>

<h2 id="Properties">Properties</h2>

<p><em>In addition to the properties listed below, <code>XRSession</code> inherits properties from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{DOMxRef("XRSession.environmentBlendMode", "environmentBlendMode")}} {{Experimental_Inline}} {{ReadOnlyInline}}</dt>
 <dd>
 <p>Returns this session's blend mode which denotes how much of the real-world environment is visible through the XR device and how the device will blend the device imagery with it.</p>

 <div class="notecard note">
 <p><strong>Note:</strong> <code>environmentBlendMode()</code> is part of the <a href="https://immersive-web.github.io/webxr-ar-module">WebXR Augmented Reality Module</a>, which has not been completed.</p>
 </div>
 </dd>
 <dt>{{DOMxRef("XRSession.inputSources", "inputSources")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a list of this session's {{DOMxRef("XRInputSource")}}s, each representing an input device used to control the camera and/or scene.</dd>
 <dt>{{DOMxRef("XRSession.renderState", "renderState")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>An {{domxref("XRRenderState")}} object which contains options affecting how the imagery is rendered. This includes things such as the near and far clipping planes (distances defining how close and how far away objects can be and still get rendered), as well as field of view information.</dd>
 <dt>{{DOMxRef("XRSession.visibilityState", "visibilityState")}} {{Experimental_Inline}}{{ReadOnlyInline}}</dt>
 <dd>A {{domxref("DOMString")}} whose value is one of those found in the {{domxref("XRVisibilityState")}} enumerated type, indicating whether or not the session's imagery is visible to the user, and if so, if it's being visible but not currently the target for user events.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em><code>XRSession</code> provides the following methods in addition to those inherited from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{DOMxRef("XRSession.cancelAnimationFrame", "cancelAnimationFrame()")}}</dt>
 <dd>Removes a callback from the animation frame painting callback from <code>XRSession</code>'s set of animation frame rendering callbacks, given the identifying handle returned by a previous call to {{domxref("XRSession.requestAnimationFrame", "requestAnimationFrame()")}}.</dd>
 <dt>{{DOMxRef("XRSession.end", "end()")}}</dt>
 <dd>Ends the WebXR session. Returns a {{jsxref("promise")}} which resolves when the session has been shut down.</dd>
 <dt>{{DOMxRef("XRSession.requestAnimationFrame", "requestAnimationFrame()")}}</dt>
 <dd>Schedules the specified method to be called the next time the {{glossary("user agent")}} is working on rendering an animation frame for the WebXR device. Returns an integer value which can be used to identify the request for the purposes of canceling the callback using <code>cancelAnimationFrame()</code>. This method is comparable to the {{domxref("Window.requestAnimationFrame()")}} method.</dd>
 <dt>{{DOMxRef("XRSession.requestReferenceSpace", "requestReferenceSpace()")}}</dt>
 <dd>Requests that a new {{domxref("XRReferenceSpace")}} of the specified type be created. Returns a promise which resolves with the <code>XRReferenceSpace</code> or {{domxref("XRBoundedReferenceSpace")}} which was requested, or throws a <code>NotSupportedError</code> if the requested space type isn't supported by the device.</dd>
 <dt>{{DOMxRef("XRSession.updateRenderState", "updateRenderState()")}}</dt>
 <dd>Updates the properties of the session's render state to match the values specified in the specified {{domxref("XRRenderStateInit")}} dictionary. Any properties not included in the given dictionary are left unchanged from their current values.</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>The following events are delivered to <code>XRSession</code> objects.</em></p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Event</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{domxref("XRSession.end_event", "end")}}</td>
   <td>Sent to the <code>XRSession</code> object after the WebXR session has ended and all hardware-related functions have completed. The event is represented by an object of type {{domxref("XRSessionEvent")}}.<br>
    Also available through the {{domxref("XRSession.onend", "onend")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.inputsourceschange_event", "inputsourceschange")}}</td>
   <td>An event of type {{domxref("XRInputSourcesChangeEvent")}} sent to the <code>XRSession</code> when the list of active XR input sources has changed.<br>
    Also available through the {{domxref("XRSession.oninputsourceschange", "oninputsourceschange")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.select_event", "select")}}</td>
   <td>An event of type {{domxref("XRInputSourceEvent")}} which is sent to the session when one of the session's input sources has successfully completed a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a>. This generally corresponds to the user pressing a trigger, touchpad, or button, speaks a command, or performs a recognizable gesture. The <code>select</code> event is sent after the <code>selectstart</code> event is sent and immediately before the <code>selectend</code> event is sent. If <code>select</code> is <em>not</em> sent, then the select action was aborted before being completed.<br>
    Also available through the {{domxref("XRSession.onselect", "onselect")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.selectend_event", "selectend")}}</td>
   <td>An event of type {{domxref("XRInputSourceEvent")}} which gets sent to the session object when one of its input devices finishes its primary action or gets disconnected while in the process of handling a primary action. For example: for button or trigger actions, this means the button has been released; for spoken commands, it means the user has finished speaking. This is the last of the three <code>select*</code> events to be sent.<br>
    Also available through the {{domxref("XRSession.onselectend", "onselectend")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.selectstart_event", "selectstart")}}</td>
   <td>An event of type <code>XRInputSourceEvent</code> which is sent to the session object when one of its input devices is first engaged by the user in such a way as to cause the primary action to begin. This is the first of the <code>session*</code> event to be sent.<br>
    Also available through the {{domxref("XRSession.onselectstart", "onselectstart")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.squeeze_event", "squeeze")}}</td>
   <td>An {{domxref("XRInputSourceEvent")}} sent to indicate that a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> has successfully completed. This indicates that the device being squeezed has been released, and may represent dropping a grabbed object, for example. It is sent immediately before the <code>squeezeend</code> event is sent to indicate that the squeeze action is over.<br>
    Also available through the {{domxref("XRSession.onsqueeze", "onsqueeze")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.squeezeend_event", "squeezeend")}}</td>
   <td>An {{domxref("XRInputSourceEvent")}} sent to the <code>XRSession</code> when the <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> ends, whether or not the action was successful.<br>
    Also available using the {{domxref("XRSession.onsqueezeend", "onsqueezeend")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.squeezestart_event", "squeezestart")}}</td>
   <td>An event of type {{domxref("XRInputSourceEvent")}} which is sent to the <code>XRSession</code> when the user initially squeezes a squeezable controller. This may be, for example, a trigger which is used to represent grabbing objects, or might represent actual squeezing when wearing a haptic glove.<br>
    Also available through the {{domxref("XRSession.onsqueezestart", "onsqueezestart")}} event handler property.</td>
  </tr>
  <tr>
   <td>{{domxref("XRSession.visibilitychange_event", "visibilitychange")}}</td>
   <td>An {{domxref("XRSessionEvent")}} which is sent to the session when its visibility state as indicated by the {{domxref("XRSession.visibilityState", "visibilityState")}} changes.<br>
    Also available through the {{domxref("XRSession.onvisibilitychange", "onvisibilitychange")}} event handler property.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>This example establishes a new <code>XRSession</code> in <code>inline</code> mode so that it can be displayed within an HTML element, avoiding the need for a dedicated AR or VR viewing device such as a headset.</p>

<pre class="brush: js">const XR = navigator.xr;

if (XR) {
  XR.requestSession("inline").then((xrSession) =&gt; {
    xrSession.requestReferenceSpace("local").then((xrReferenceSpace) =&gt; {
      xrSession.requestAnimationFrame((time, xrFrame) =&gt; {
        let viewer = xrFrame.getViewerPose(xrReferenceSpace);

        gl.bindFramebuffer(xrWebGLLayer.framebuffer);

        for (xrView of viewer.views) {
          let xrViewport = xrWebGLLayer.getViewport(xrView);
          gl.viewport(xrViewport.x, xrViewport.y,
                      xrViewport.width, xrViewport.height);
        }
      });
    });
  });
} else {
  /* WebXR is not available */
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrsession-interface","XRSession")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession")}}</div>
